
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C# 调用C++ DLL 的类型转换（转载版） / 憋错料</title>

    <meta name="description" content="C# 调用C++ DLL 的类型转换（转载版） 最近在做视频监控相关的demo开发,实现语言是C#,但视频监控的SDK是C++开发的,所以涉及到C#调用C++的dll库.很多结构体.参数在使用时都要先进行转换,由非托管类型转换成托管类型后才能使用.以下是查到的比较好用的类型转换总结. 转载地址:http://www.cnblogs.com/blackice/archive/2013/05/23/3094653.html 1 //C#调用C++的DLL搜集整理的所有数据类型转换方式,可能会有重复或者多种方案,自己多测试 2 //c++:HAND">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">C# 调用C++ DLL 的类型转换（转载版）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>　　最近在做视频监控相关的demo开发，实现语言是C#，但视频监控的SDK是C++开发的，所以涉及到C#调用C++的dll库。很多结构体、参数在使用时都要先进行转换，由非托管类型转换成托管类型后才能使用。以下是查到的比较好用的类型转换总结。</p>
<p>转载地址：http://www.cnblogs.com/blackice/archive/2013/05/23/3094653.html</p>
<pre>  1 //C#调用C++的DLL搜集整理的所有数据类型转换方式,可能会有重复或者多种方案,自己多测试
  2    //c++:HANDLE(void *) ---- c#:System.IntPtr
  3    //c++:Byte(unsigned char) ---- c#:System.Byte
  4    //c++:SHORT(short) ---- c#:System.Int16
  5    //c++:WORD(unsigned short) ---- c#:System.UInt16
  6    //c++:INT(int) ---- c#:System.Int16
  7    //c++:INT(int) ---- c#:System.Int32
  8    //c++:UINT(unsigned int) ---- c#:System.UInt16
  9    //c++:UINT(unsigned int) ---- c#:System.UInt32
 10    //c++:LONG(long) ---- c#:System.Int32
 11    //c++:ULONG(unsigned long) ---- c#:System.UInt32
 12    //c++:DWORD(unsigned long) ---- c#:System.UInt32
 13    //c++:DECIMAL ---- c#:System.Decimal
 14    //c++:BOOL(long) ---- c#:System.Boolean
 15    //c++:CHAR(char) ---- c#:System.Char
 16    //c++:LPSTR(char *) ---- c#:System.String
 17    //c++:LPWSTR(wchar_t *) ---- c#:System.String
 18    //c++:LPCSTR(const char *) ---- c#:System.String
 19    //c++:LPCWSTR(const wchar_t *) ---- c#:System.String
 20    //c++:PCAHR(char *) ---- c#:System.String
 21    //c++:BSTR ---- c#:System.String
 22    //c++:FLOAT(float) ---- c#:System.Single
 23    //c++:DOUBLE(double) ---- c#:System.Double
 24    //c++:VARIANT ---- c#:System.Object
 25    //c++:PBYTE(byte *) ---- c#:System.Byte[]
 26
 27
 28   //c++:BSTR ---- c#:StringBuilder
 29    //c++:LPCTSTR ---- c#:StringBuilder
 30    //c++:LPCTSTR ---- c#:string
 31    //c++:LPTSTR ---- c#:[MarshalAs(UnmanagedType.LPTStr)] string
 32    //c++:LPTSTR 输出变量名 ---- c#:StringBuilder 输出变量名
 33    //c++:LPCWSTR ---- c#:IntPtr
 34    //c++:BOOL ---- c#:bool
 35    //c++:HMODULE ---- c#:IntPtr
 36    //c++:HINSTANCE ---- c#:IntPtr
 37    //c++:结构体 ---- c#:public struct 结构体{};
 38    //c++:结构体 **变量名 ---- c#:out 变量名 //C#中提前申明一个结构体实例化后的变量名
 39    //c++:结构体 &amp;变量名 ---- c#:ref 结构体 变量名
 40
 41
 42
 43   //c++:WORD ---- c#:ushort
 44    //c++:DWORD ---- c#:uint
 45    //c++:DWORD ---- c#:int
 46
 47
 48   //c++:UCHAR ---- c#:int
 49    //c++:UCHAR ---- c#:byte
 50    //c++:UCHAR* ---- c#:string
 51    //c++:UCHAR* ---- c#:IntPtr
 52
 53
 54   //c++:GUID ---- c#:Guid
 55    //c++:Handle ---- c#:IntPtr
 56    //c++:HWND ---- c#:IntPtr
 57    //c++:DWORD ---- c#:int
 58    //c++:COLORREF ---- c#:uint
 59
 60
 61
 62
 63   //c++:unsigned char ---- c#:byte
 64    //c++:unsigned char * ---- c#:ref byte
 65    //c++:unsigned char * ---- c#:[MarshalAs(UnmanagedType.LPArray)] byte[]
 66    //c++:unsigned char * ---- c#:[MarshalAs(UnmanagedType.LPArray)] Intptr
 67
 68
 69   //c++:unsigned char &amp; ---- c#:ref byte
 70    //c++:unsigned char 变量名 ---- c#:byte 变量名
 71    //c++:unsigned short 变量名 ---- c#:ushort 变量名
 72    //c++:unsigned int 变量名 ---- c#:uint 变量名
 73    //c++:unsigned long 变量名 ---- c#:ulong 变量名
 74
 75
 76   //c++:char 变量名 ---- c#:byte 变量名 //C++中一个字符用一个字节表示,C#中一个字符用两个字节表示
 77    //c++:char 数组名[数组大小] ---- c#:MarshalAs(UnmanagedType.ByValTStr, SizeConst = 数组大小)] public string 数组名; ushort
 78
 79
 80   //c++:char * ---- c#:string //传入参数
 81    //c++:char * ---- c#:StringBuilder//传出参数
 82    //c++:char *变量名 ---- c#:ref string 变量名
 83    //c++:char *输入变量名 ---- c#:string 输入变量名
 84    //c++:char *输出变量名 ---- c#:[MarshalAs(UnmanagedType.LPStr)] StringBuilder 输出变量名
 85
 86
 87   //c++:char ** ---- c#:string
 88    //c++:char **变量名 ---- c#:ref string 变量名
 89    //c++:const char * ---- c#:string
 90    //c++:char[] ---- c#:string
 91    //c++:char 变量名[数组大小] ---- c#:[MarshalAs(UnmanagedType.ByValTStr,SizeConst=数组大小)] public string 变量名;
 92
 93
 94   //c++:struct 结构体名 *变量名 ---- c#:ref 结构体名 变量名
 95    //c++:委托 变量名 ---- c#:委托 变量名
 96
 97
 98   //c++:int ---- c#:int
 99    //c++:int ---- c#:ref int
100    //c++:int &amp; ---- c#:ref int
101    //c++:int * ---- c#:ref int //C#中调用前需定义int 变量名 = 0;
102
103
104   //c++:*int ---- c#:IntPtr
105    //c++:int32 PIPTR * ---- c#:int32[]
106    //c++:float PIPTR * ---- c#:float[]
107
108
109
110   //c++:double** 数组名 ---- c#:ref double 数组名
111    //c++:double*[] 数组名 ---- c#:ref double 数组名
112    //c++:long ---- c#:int
113    //c++:ulong ---- c#:int
114
115    //c++:UINT8 * ---- c#:ref byte //C#中调用前需定义byte 变量名 = new byte();
116
117
118
119
120   //c++:handle ---- c#:IntPtr
121    //c++:hwnd ---- c#:IntPtr
122
123
124    //c++:void * ---- c#:IntPtr
125    //c++:void * user_obj_param ---- c#:IntPtr user_obj_param
126    //c++:void * 对象名称 ---- c#:([MarshalAs(UnmanagedType.AsAny)]Object 对象名称
127
128
129
130
131
132    //c++:char, INT8, SBYTE, CHAR ---- c#:System.SByte
133    //c++:short, short int, INT16, SHORT ---- c#:System.Int16
134    //c++:int, long, long int, INT32, LONG32, BOOL , INT ---- c#:System.Int32
135    //c++:__int64, INT64, LONGLONG ---- c#:System.Int64
136    //c++:unsigned char, UINT8, UCHAR , BYTE ---- c#:System.Byte
137    //c++:unsigned short, UINT16, USHORT, WORD, ATOM, WCHAR , __wchar_t ---- c#:System.UInt16
138    //c++:unsigned, unsigned int, UINT32, ULONG32, DWORD32, ULONG, DWORD, UINT ---- c#:System.UInt32
139    //c++:unsigned __int64, UINT64, DWORDLONG, ULONGLONG ---- c#:System.UInt64
140    //c++:float, FLOAT ---- c#:System.Single
141    //c++:double, long double, DOUBLE ---- c#:System.Double
142
143
144   //Win32 Types ---- CLR Type
145
146
147
148   //Struct需要在C#里重新定义一个Struct
149    //CallBack回调函数需要封装在一个委托里，delegate static extern int FunCallBack(string str);
150
151
152   //unsigned char** ppImage替换成IntPtr ppImage
153    //int&amp; nWidth替换成ref int nWidth
154    //int*, int&amp;, 则都可用 ref int 对应
155    //双针指类型参数，可以用 ref IntPtr
156    //函数指针使用c++: typedef double (*fun_type1)(double); 对应 c#:public delegate double fun_type1(double);
157    //char* 的操作c++: char*; 对应 c#:StringBuilder;
158    //c#中使用指针:在需要使用指针的地方 加 unsafe
159
160
161
162
163   //unsigned char对应public byte
164    /*
165    * typedef void (*CALLBACKFUN1W)(wchar_t*, void* pArg);
166    * typedef void (*CALLBACKFUN1A)(char*, void* pArg);
167    * bool BIOPRINT_SENSOR_API dllFun1(CALLBACKFUN1 pCallbackFun1, void* pArg);
168    * 调用方式为
169    * [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
170    * public delegate void CallbackFunc1([MarshalAs(UnmanagedType.LPWStr)] StringBuilder strName, IntPtr pArg);
171    *
172    *
173    */</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 10:09:43 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/ons/" title="ons">ons</a>, <a href="https://www.biecuoliao.com/tag/pre/" title="pre">pre</a>, <a href="https://www.biecuoliao.com/tag/%e6%b5%8b%e8%af%95/" title="测试">测试</a>, <a href="https://www.biecuoliao.com/tag/%e5%ae%9e%e7%8e%b0/" title="实现">实现</a>, <a href="https://www.biecuoliao.com/tag/long/" title="long">long</a>, <a href="https://www.biecuoliao.com/tag/pst/" title="pst">pst</a>, <a href="https://www.biecuoliao.com/tag/%e7%b1%bb%e5%9e%8b%e8%bd%ac%e6%8d%a2/" title="类型转换">类型转换</a>, <a href="https://www.biecuoliao.com/tag/asa/" title="asa">asa</a>, <a href="https://www.biecuoliao.com/tag/cdecl/" title="cdecl">cdecl</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>C# 调用C++ DLL 的类型转换（转载版）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBEXaA4.html" rel="bookmark">C&num; 调用C&plus;&plus; DLL 的类型转换</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				//C#调用C++的DLL搜集整理的所有数据类型转换方式,可能会有重复或者多种方案,自己多测试 //c++:HANDLE(void *) ---- c#:System.IntPtr //c++:Byte(unsigned char) ---- c#:System.Byte //c++:SHORT(short) ---- c#:System.Int16 //c++:WORD(unsigned short) ---- c#:System.UInt16 //c++:INT(int) ---- c#:S			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Moqzal3.html" rel="bookmark">C&plus;&plus;、C&num;互调用之C&plus;&plus; 调用C&num; dll （转载）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.c# 创建dll 建立C#编写的DLL程序AddDll,项目类型为:类库 程序代码: using System; using System.Collections.Generic; using System.Text; namespace AddDll { public class Add { public int iadd(int a, int b) { int c = a + b; return c; } } } 2.C++编写调用程序 建立C++的Win32控制台应用程序UseDll,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JYPl93.html" rel="bookmark">Native Application 开发详解（直接在程序中调用 ntdll&period;dll 中的 Native API，有内存小、速度快、安全、API丰富等8大优点）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章目录:                   1. 引子: 2. Native Application Demo 展示: 3. Native Application 简介: 4. Native Application 有何妙用: 5. MJ0011 关于 Native Application 的文章整理: 6. 互联网上其他关于 Native Application 的文章整理: 7. 小结: 1. 引子: 其实在好久以前就看了 MJ0011 翻译的那个&lt;Native 应用程序详细&gt;系列的文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ODAbG4.html" rel="bookmark">VC调用matlab dll方式混合编程（c风格--例2）&amp;lt&semi;二&amp;gt&semi;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				VC与Matlab混合编程之调用动态链接库dll--&lt;二&gt; 1.是先建立 matlab 的 m 文件. ellipsefit.m 其包含:function [Xc,Yc,A,B,Phi,P]=ellipsefit(x,y) 2.MCC命令编译生成得到h.dll.lib等文件 在matlab命令行中输入: mcc -B csharedlib:ellipsefit ellipsefit.m (此方式为c风格函数) (具体命令含义可参考&lt;精通matlab与C/C++混合程序设计&gt;刘维,第			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aYP5g0.html" rel="bookmark">VC与Matlab混合编程之调用动态链接库dll&lpar;C&plus;&plus;&rpar;&mdash;&mdash;&amp;lt&semi;二&amp;gt&semi;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				VC与Matlab混合编程之调用动态链接库dll--&lt;二&gt; 1.是先建立 matlab 的 m 文件. ellipsefit.m 其包含:function [Xc,Yc,A,B,Phi,P]=ellipsefit(x,y) 2.MCC命令编译生成得到h.dll.lib等文件 在matlab命令行中输入: mcc -W cpplib:ellipsefit ellipsefit.m -T link:lib (此方式为c++风格函数) (具体命令含义可参考&lt;精通matlab与C/C++混合程序			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/471pGR0.html" rel="bookmark">&lbrack;JNI&rsqb;  Java 调用 C&plus;&plus;  dll</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先介绍一下JNI吧! JNI 是Java提供的一个用于调用本地接口的接口层,位于Java代码 和 本地代码之间的一层:主要功能是 数据类型的转换,还有就是通过这一层来调用本地代码! 下面就说说Java 调用 C++  dll是怎么实现的吧! 1.首先用Java代码制作接口层 package NEU.SOFT; public class NEUdll { public NEUdll() { } //供Java调用的本地代码 public native char[] Descrypt(boolea			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Moq61B3.html" rel="bookmark">C&num;时常需要调用C&plus;&plus;DLL</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在合作开发时,C#时常需要调用C++DLL,当传递参数时时常遇到问题,尤其是传递和返回字符串是,现总结一下,分享给大家: VC++中主要字符串类型为:LPSTR,LPCSTR, LPCTSTR, string, CString, LPCWSTR, LPWSTR等但转为C#类型却不完全相同. 主要有如下几种转换: 将string转为IntPtr:IntPtr System.Runtime.InteropServices.Marshal.StringToCoTaskMemAuto(string) 将			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Q3qNlG4.html" rel="bookmark">C&num; 调用win32 DLL报错  System&period;BadImageFormatException</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C# 调用win32 DLL报错  System.BadImageFormatException 项目右键属性-&gt;项目设计器-&gt;生成-&gt;平台-&gt;把'默认设置(任何 CPU)'改为x86. 因为'任何 CPU'的程序在64位的机器上就会用运行为64位,而64程序是不能加载32位dll的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QWL9N0.html" rel="bookmark">JNI java调用动态链接库dll</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				现在做的项目中就用到了JNI调用c语言实现的访问设备的dll文件,在此之前对JNI是一窍不通哈,只听说过JNA链接dll,但只是一个了解. JNI(Java Native Interface)Java本地接口,主要作用是实现java代码与C C++编写的代码交互. 理论不多说,还是看java链接dll具体操作吧..如下: 以下实例为java中调用connection.dll文件中的 open()方法. 1,java方 1)装载dll文件 有两种方式System.load();和System.lo			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MBVQKM.html" rel="bookmark" class="title">C&num;中的常见集合类的比较</a>
					<div>
						一.非泛型集合与泛型集合 非泛型集合:Array.ArrayList.HashTable.Queue.Statck.SortedList 泛型集合:List.Dictionary.Queue.Stac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/7MVjxzM.html" rel="bookmark" class="title">shell文件描述符及重定向</a>
					<div>
						文件描述符是与文件输入.输出相关联的整数.它用来跟踪已经打开的文件.最常见的文件描述符是stdin.stdout.stderr.我们甚至可以将某个文件描述的内容重定向到另一个文件描述符中.文件描述符0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPNEEm3.html" rel="bookmark" class="title">CentOS6&period;4下使用默认的文档查看器打开PDF文档乱码的解决方案</a>
					<div>
						 最近在CentOS6.4下使用其默认的文档查看器打开PDF文档时出现乱码的方块,有两种方法可以解决.    方法一:修改/etc/fonts/conf.d/49-sansserif.conf文件,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OalpXM.html" rel="bookmark" class="title">学习Bootstrap的必要性</a>
					<div>
						1.节省时间 利用Bootstrap,你将有更多的时间用来挣钱.Bootstrap库中包含很多现成的代码片段,这些代码可为你的网站增加更多活力.Web开发者不必再花费时间.费力地编码,只需找到合适的代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDZEBp3.html" rel="bookmark" class="title">《FPGA全程进阶---实战演练》第二章之焊接板子及调试注意事项</a>
					<div>
						1.若是读者第一次做板子,强烈建议画完PCB板后将PCB图打印出来,然后对照你买的芯片将芯片放置对 应的位置,然后查看所有的封装格式适不适合,否则等你做出板子来后再试,为时晚矣.笔者虽然知道要这么 做 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV8mGd3.html" rel="bookmark" class="title">12个JavaScript技巧【转】</a>
					<div>
						使用!!操作符转换布尔值 有时候我们需要对一个变量查检其是否存在或者检查值是否有一个有效值,如果存在就返回true值.为了做这样的验证,我们可以使用!!操作符来实现是非常的方便与简单.对于变量可以使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDoq184.html" rel="bookmark" class="title">软件测试&mdash;&mdash;读《构建之法》有感</a>
					<div>
						泛读邹欣老师的&lt;构建之法(第二版)&gt;之后,我对软件测试有了新的定义:不仅仅是测试,还包括一系列编程思想,处理问题方式以及如何团队合作. 市面上一些软件架构书.测试书一般风格呆板,就是简单直 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kZL2zM.html" rel="bookmark" class="title">python 深浅拷贝 进阶</a>
					<div>
						主要理解新与旧到底在哪里 这样也就理解了 深浅拷贝 先说说赋值,其实python中的赋值其实是赋值了一个引用,例如: foo1=1.0 foo2=foo1 用操作符is判断时,你可以发现结果是true ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmAdNXM.html" rel="bookmark" class="title">最长上升子序列之基础</a>
					<div>
						Font Size:Aa Aa Aa Description 给出一个由n个数组成的序列x[1..n],找出它的最长单调上升子序列的长度.即找出最大的长度m和a1, a2--,am,使得 a1 &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KOkVY0.html" rel="bookmark" class="title">AngulatJS多个控制器内数据共享</a>
					<div>
						利用factory和service方法定义服务,通过两个控制器利用同一个服务达到控制器间数据共享的效果. &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDye970.html" rel="bookmark" class="title">产品经理推动关键：利益相关者分析</a>
					<div>
						今天跟朋友聚会,请假一天,明天补上,题目如上. 产品经理推动关键:利益相关者分析,布布扣,bubuko.com					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ek59v4.html" rel="bookmark" class="title">centos7&plus;php&plus;nginx&plus;mysql安装</a>
					<div>
						mysql安装: 1.下载mysql的repo源 wget http://repo.mysql.com/mysql-community-release-el7-5.noarch.rpm 2.安装mys ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JdddV0.html" rel="bookmark" class="title">camera报错经典问题</a>
					<div>
						--- 33u&gt;: error: undefined reference to 'NSFeature::RAWSensorInfo&lt;22133u&gt;::impGetDefaultDat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02yw7zM.html" rel="bookmark" class="title">UVA - 101 The Blocks Problem（STL，模拟）</a>
					<div>
						The Blocks Problem Time Limit: 3000MS   Memory Limit: Unknown   64bit IO Format: %lld &amp; %llu Sub ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWr6zk4.html" rel="bookmark" class="title">Linux经常使用的命令&lpar;十&rpar; - nl</a>
					<div>
						nl命令在linux系统中用来计算文件里行号. nl 能够将输出的文件内容自己主动的加上行号.其默认的结果与 cat -n 有点不太一样. nl 能够将行号做比較多的显示设计,包含位数与是否自己主动补 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGe1xQ3.html" rel="bookmark" class="title">uva1291</a>
					<div>
						这题说的给了 一 个 图,每次 按照他给的顺序 跳格子 给了 每种 格子之间的 转换 代价 求最后 转换代价 dp[i][j] 表示 左脚在i 右脚 在j 的最小代价 然后用滚动数组 ,就可以不断说的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPXnkmM.html" rel="bookmark" class="title">&lbrack;hadoop&rsqb;Windows下eclipse导入hadoop源码，编译WordCount</a>
					<div>
						hadoop版本为hadoop1.2.1 eclipse版本为eclipse-standard-kepler-SR2-win32-x86_64 WordCount.java为hadoop-1.2.1\ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pg2rg3.html" rel="bookmark" class="title">Mysql利用match&period;&period;&period;against进行全文检索</a>
					<div>
						在电商项目中,最核心的功能之一就是搜索功能,搜索做的好,整个电商平台就是个优秀的平台.一般搜索功能都使用搜索引擎如Lucene.solr.elasticsearch等,虽然这功能比较强大,但是对于一些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mm7wKV3.html" rel="bookmark" class="title">C&sol;C&plus;&plus; struct&sol;class&sol;union内存对齐</a>
					<div>
						struct/class/union内存对齐原则有四个: 1).数据成员对齐规则:结构(struct)(或联合(union))的数据成员,第一个数据成员放在offset为0的地方,以后每个数据成员存储 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OQ1EZM.html" rel="bookmark" class="title">昂贵的聘礼 - poj 1062 &lpar;Dijkstra&plus;枚举&rpar;</a>
					<div>
						Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 39976   Accepted: 11596 Description 年轻的 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
